Subject: bug#16232: [PATCH] grep: make --ignore-case (-i) faster (sometimes 10x) in multibyte locales

From: Jim Meyering <[email-masked]>
Date: Thu, 20 Feb 2014 16:54:54 -0800

PS. if anyone has really slow hardware on which they can
exercise this test, I'd appreciate your letting me know if you can make
this new test fail.  I chose the "4-second" limit presuming that there are
few systems slow enough that they'd take longer than that.

Technically, you could probably test with grep-2.16, if that's easier
(but not 2.17).  Run these commands:

  grep --version
  yes $(printf '%078d' 0)|head -50000 > k
  env LC_ALL=ja_JP.eucJP time grep -i foobar k

[use src/grep in place of "grep" above, if you're testing just-build grep
 -- but in that case, you can just run "make check"]

and let me know if it takes longer than 4 seconds.
Ideally, I would compare timings of two commands, one with the offending
locale, and the other with LC_ALL=C.  That would eliminate the scaling issue.